VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Ejemplo"
   ClientHeight    =   4155
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6645
   LinkTopic       =   "Form1"
   ScaleHeight     =   4155
   ScaleWidth      =   6645
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Datos"
      Height          =   3495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6375
      Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
         Height          =   3135
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   6135
         _ExtentX        =   10821
         _ExtentY        =   5530
         _Version        =   393216
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Cargar"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   3720
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ----------------------------------------------------------------------------------------------
' \\ -- DEscripcin : Simple ejemplo para cargar imagenes de productos de una base de datos en un GRdi MsFlexgrid
'    -- Autor       : Luciano Lodola -- http://www.recursosvisualbasic.com.ar/
' ----------------------------------------------------------------------------------------------
' ----------------------------------------------------------------------------------------------


Private Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Private Declare Sub InitCommonControls Lib "Comctl32" ()


' \\ -- Tamao de las imagenes de cada producto:
'    -- 64 pixeles cada una -- para la propiedad Rowheight del Grid)
Private Const IMAGE_HEIGHT As Long = 64
Private cn                 As Connection            ' -- Variable para la conexin ADO


' -------------------------------------------------------------------------------------------
' \\ -- Inicio
' -------------------------------------------------------------------------------------------
Private Sub Form_Load()
    ' -- Iniciar la conexin a la base de datos
    Call pvConectDataBase
End Sub
' -------------------------------------------------------------------------------------------
' \\ -- Rutina para obtener los registros de la base de datos y llenar el Grid con los datos y la imagen asociada de cada producto.
'    -- La imagen es el nmero de ID que corresponde al nombre del archivo JPG
' -------------------------------------------------------------------------------------------
Private Sub Cargar_MsFlexGrid(cn As Connection, sQuery As String, MsFlexGrid As MsFlexGrid, sImageField As String)
    
    On Error GoTo Error_Handler:
    
    Dim rs                  As Recordset    ' -- Variable para el recordset
    Dim iCol                As Integer      ' -- Variable para el ndice de columna dentro del bucle
    
    ' -- Crear un nuevo recordset
    Set rs = New Recordset
    ' -- Abrirlo pasndole la consulta Sql y la conexin
    rs.Open sQuery, cn
    
    With MsFlexGrid
        ' -- Para que al hacer click seleccione la fila completa ( Opcional )
        .SelectionMode = flexSelectionByRow
        .AllowUserResizing = flexResizeColumns
        ' -- Ancho de la imagen ( 60 pixeles + 2 para el margen )
        .RowHeightMin = (IMAGE_HEIGHT * Screen.TwipsPerPixelX) + (Screen.TwipsPerPixelX * 2)
        
        ' -- Ancho de la columna que tiene los grficos ( El mismo valor que el anterior )
        .ColWidth(0) = .RowHeightMin
        ' -- Encabezados superiores
        .FixedCols = 0
        .FixedRows = 1
        ' -- Cantidad de columnas de la grilla
        .Cols = rs.Fields.Count + 1
        ' -- Alto del encabezado
        .Row = 1
        .RowHeight(0) = 250
        ' -- Deshabilitar la actualizacin del Grid por si se cargan muchos datos
        .Redraw = False
        ' -- Texto del primer encabezado ( Columna con la imagen del producto )
        .TextMatrix(0, 0) = "Imagen     "
        ' -- Recorrer los campos
        For iCol = 0 To rs.Fields.Count - 1
            ' -- Alinear los datos
            .Col = iCol
            .ColAlignment(iCol) = 1
            ' -- Establecer el texto del encabezado
            .TextMatrix(0, iCol + 1) = rs.Fields(iCol).Name
            .ColWidth(iCol + 1) = .RowHeightMin
        Next
        ' -- Recorrer todos los registros
        While Not rs.EOF
            ' -- Nueva fila
            .Rows = .Rows + 1
            ' -- Establecer la fila activa
            .Row = .Row + 1
            ' -- Establecer columna activa ( Para la imagen )
            .Col = 0
            ' -- Leer la imagen desde el disco y Establecerla en la celda
            Set .CellPicture = LoadPicture(App.Path & "\imagenes\" & rs(sImageField) & ".jpg")
            ' -- Recorrer los campos
            For iCol = 0 To rs.Fields.Count - 1
                ' -- Establecer el dato de cada celda
                .TextMatrix(.Row, iCol + 1) = IIf(IsNull(rs.Fields(iCol)), vbNullString, rs.Fields(iCol))
            Next
            ' -- Mover el punteo al siguiente registro
            rs.MoveNext
        Wend
       
        ' -- Cerrar el recordset y destruir la variable
        
        rs.Close
        Set rs = Nothing
        
        ' -- Eliminar la primer fila vaca
        .RemoveItem 1
        ' -- Habilita nuevamente el Repintado del control
        .Redraw = True
    End With
        
' -- Errores ...
Exit Sub
Error_Handler:
MsgBox Err.Description, vbCritical
    
End Sub
' --------------------------------------------------------------------------------------------
' \\ -- Botn para volcar los datos al Grid
' --------------------------------------------------------------------------------------------
Private Sub Command1_Click()
    Call Cargar_MsFlexGrid(cn, "Select producto,precio,id From tProductos", MSFlexGrid1, "ID")
End Sub
' --------------------------------------------------------------------------------------------
' \\ -- Subrutina para conectar
' --------------------------------------------------------------------------------------------
Private Sub pvConectDataBase()
    On Error GoTo Error_Handler
    ' -- Crear conexin
    Set cn = New Connection
    With cn
        .CursorLocation = adUseClient
        .Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\data\db1.mdb" & ";Persist Security Info=False"
    End With
' -- Errores
Exit Sub
Error_Handler:
MsgBox Err.Number & " " & " Error " & Err.Description, vbCritical
End Sub
' --------------------------------------------------------------------------------------------
' \\ -- Cerrar conexin
' --------------------------------------------------------------------------------------------
Private Sub pvCloseDataBase()
    If Not cn Is Nothing Then
       If cn.State = adStateOpen Then cn.Close
       Set cn = Nothing
    End If
End Sub
' --------------------------------------------------------------------------------------------
' \\ -- Fin
' --------------------------------------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)
    Call pvCloseDataBase
End Sub
' --------------------------------------------------------------------------------------------
' \\ -- Iniciar InitCommonControls
' --------------------------------------------------------------------------------------------
Private Sub Form_Initialize()
    Call SetErrorMode(2)
    Call InitCommonControls
End Sub


